﻿Imports System
Imports System.Windows
Imports System.Windows.Media

Public Class Font
    Implements IEquatable(Of Font)
    Public Sub New()
        Me.New("")
    End Sub

    Public Sub New(ByVal fontFamily As String)
        Me.New(fontFamily, FontStyles.Normal, FontWeights.Normal)
    End Sub

    Public Sub New(ByVal fontFamily As String, ByVal fontStyle As FontStyle, ByVal fontWeight As FontWeight)
        Me.FontFamily = New FontFamily(fontFamily)
        Me.FontStyle = fontStyle
        Me.FontWeight = fontWeight
    End Sub

    Private _FontFamily As FontFamily
    Public Property FontFamily() As FontFamily
        Get
            Return _FontFamily
        End Get
        Protected Set(ByVal value As FontFamily)
            _FontFamily = value
        End Set
    End Property

    Private _FontStyle As FontStyle
    Public Property FontStyle() As FontStyle
        Get
            Return _FontStyle
        End Get
        Protected Set(ByVal value As FontStyle)
            _FontStyle = value
        End Set
    End Property

    Private _FontWeight As FontWeight
    Public Property FontWeight() As FontWeight
        Get
            Return _FontWeight
        End Get
        Protected Set(ByVal value As FontWeight)
            _FontWeight = value
        End Set
    End Property

    Public Overloads Function Equals(ByVal that As Font) As Boolean Implements IEquatable(Of Font).Equals
        Return Me.FontFamily.Equals(that.FontFamily) AndAlso Me.FontStyle.Equals(that.FontStyle) AndAlso Me.FontWeight.Equals(that.FontWeight)
    End Function
End Class