﻿Imports System.Windows
Imports System.Windows.Controls

Public Class FontMetrics
    Private Const EmSize As Integer = 2048
    Private txtblk As TextBlock
    Private height As Double
    Private charWidths(255)() As Double

    Public Sub New(ByVal font As Font)
        Me.Font = font

        ' Create the TextBlock for all measurements
        txtblk = New TextBlock With {.FontFamily = Me.Font.FontFamily, .FontStyle = Me.Font.FontStyle, .FontWeight = Me.Font.FontWeight, .FontSize = EmSize}

        ' Store the character height
        txtblk.Text = " "
        height = txtblk.ActualHeight / EmSize
    End Sub

    Private _Font As Font
    Public Property Font() As Font
        Get
            Return _Font
        End Get
        Protected Set(ByVal value As Font)
            _Font = value
        End Set
    End Property

    Default Public ReadOnly Property Item(ByVal ch As Char) As Double
        Get
            ' Break apart the character code
            Dim upper As Integer = CUShort(AscW(ch)) >> 8
            Dim lower As Integer = CUShort(AscW(ch)) And &HFF

            ' If there's no array, create one
            If charWidths(upper) Is Nothing Then
                charWidths(upper) = New Double(255) {}

                For i = 0 To 255
                    charWidths(upper)(i) = -1
                Next i
            End If

            ' If there's no character width, obtain it
            If charWidths(upper)(lower) = -1 Then
                txtblk.Text = ch.ToString()
                charWidths(upper)(lower) = txtblk.ActualWidth / EmSize
            End If
            Return charWidths(upper)(lower)
        End Get
    End Property

    Public Function MeasureText(ByVal text As String) As Size
        Dim accumWidth As Double = 0

        For Each ch In text
            accumWidth += Me(ch)
        Next ch

        Return New Size(accumWidth, height)
    End Function

    Public Function MeasureText(ByVal text As String, ByVal startIndex As Integer, ByVal length As Integer) As Size
        Dim accumWidth As Double = 0

        For index = startIndex To startIndex + length - 1
            accumWidth += Me(text.Chars(index))
        Next index

        Return New Size(accumWidth, height)
    End Function
End Class